<?php

class AuthorizeController extends Zend_Controller_Action
{

    public function init()
    {
        /* Initialize action controller here */
    }

    public function indexAction()
    {
        // not used
    }

    public function loginAction()
    {
        // action body (for logging in)
        //http://framework.zend.com/manual/1.12/en/learning.multiuser.authentication.html
        $db = $this->_getParam('db');
        
        $loginForm = new Application_Form_Login();
        
        if ($this->getRequest()->isPost() && $loginForm->isValid($_POST)){
            
            $adapter = new Zend_Auth_Adapter_DbTable(
                    $db,
                    'users',//table name
                    'use_name',//column for username
                    'use_pwd',//column for hashed password
                    'BINARY SHA2(CONCAT(use_salt, ?),512)'//call to mysql to hash user-supplied password
                    );
            
            $adapter->setIdentity($loginForm->getValue('username'));
            $adapter->setCredential($loginForm->getValue('password'));
            
            $auth = Zend_Auth::getInstance();
            $result = $auth->authenticate($adapter);
            
            if ($result->isValid()) {
                $this->_helper->FlashMessenger('Successful Login');
                $this->_redirect('/');
                return;
            }
            else 
            {
                //username and/or pwd didn't match
                $loginForm->setErrors(array('Invalid username or password.'));
                $loginForm->addDecorator('Errors', array('placement' => 'append'));
            }
            
        }
        
        $this->view->form = $loginForm;
        
    }

    public function logoutAction()
    {
        // action body (for logging out)
        //http://robertbasic.com/blog/login-example-with-zend_auth/    
        # clear everything - session is cleared also!
        Zend_Auth::getInstance()->clearIdentity();
        $this->_redirect('authorize/login');
    
    }


}





