<?php

//form for deleting employees
//"application form" means a form for the application
//not an application form in the sense of applying for a job
class Application_Form_EmployeeDelete extends Zend_Form
{

    public function init()
    {
        // Set the method for the display form to POST
        $this->setMethod('post');
        
        // All elements are read-only
        
        // Add an id element
        $this->addElement('text', 'emp_no', array(
            'label'      => 'Employee ID:',
            'required'   => true,
            'readonly'   => true,
            'filters'    => array('StringTrim')
        ));
 
        // Add a first name element
        $this->addElement('text', 'first_name', array(
            'label'      => 'First name:',
            'required'   => true,
            'readonly'   => true,
            'filters'    => array('StringTrim')
        ));
 
        // Add the last name element
        $this->addElement('text', 'last_name', array(
            'label'      => 'Last name:',
            'required'   => true,
            'readonly'   => true,
            'filters'    => array('StringTrim')
        ));
        
        // Add the gender element
        $this->addElement('text', 'gender', array(
            'label'      => 'Gender:',
            'required'   => true,
            'readonly'   => true,
            'filters'    => array('StringTrim')
        ));
 
        //BIRTH DATE chunks
                // Year
        $this->addElement('text', 'byear', array(
            'label'      => 'Birth Date :: Year:',
            'required'   => true,
            'readonly'   => true,
            'style' => 'width:75px;',
            'filters'    => array('StringTrim'),
            'decorators' => array('Errors','Label',
            'ViewHelper'),
            'validators' => array(
               array('Between', false, array('min' => 1900, 'max' => 9999)))
        ));
                // Month
        $this->addElement('text', 'bmonth', array(
            'label'      => 'Month:',
            'required'   => true,
            'readonly'   => true,
            'style' => 'width:40px;',
            'filters'    => array('StringTrim'),
            'decorators' => array('Errors','Label',
            'ViewHelper'),
            'validators' => array(
               array('Between', false, array('min' => 1, 'max' => 12)))
        ));
                // Day
        $this->addElement('text', 'bday', array(
            'label'      => 'Day:',
            'required'   => true,
            'readonly'   => true,
            'style' => 'width:40px;',
            'filters'    => array('StringTrim'),
            'decorators' => array('Errors','Label',
            'ViewHelper'),
            'validators' => array(
               array('Between', false, array('min' => 1, 'max' => 31)))
        ));
        //http://zend-framework-community.634137.n4.nabble.com/Zend-Form-Decorators-Multiple-Buttons-On-One-Line-td642790.html
        $this->addDisplayGroup(array('byear', 'bmonth', 'bday'), 'birthDate', array( 
        'decorators' => array( 
            'FormElements', 
            array('HtmlTag', array('tag' => 'p', 'class' => 'element')), 
        ), 
        )); 

        //HIRE DATE chunks
                // Year
        $this->addElement('text', 'hyear', array(
            'label'      => 'Hire Date :: Year:',
            'required'   => true,
            'readonly'   => true,
            'style' => 'width:75px;',
            'filters'    => array('StringTrim'),
            'decorators' => array('Errors','Label',
            'ViewHelper'),
            'validators' => array(
               array('Between', false, array('min' => 1900, 'max' => 9999)))
        ));
                // Month
        $this->addElement('text', 'hmonth', array(
            'label'      => 'Month:',
            'required'   => true,
            'readonly'   => true,
            'style' => 'width:40px;',
            'filters'    => array('StringTrim'),
            'decorators' => array('Errors','Label',
            'ViewHelper'),
            'validators' => array(
               array('Between', false, array('min' => 1, 'max' => 12)))
        ));
                // Day
        $this->addElement('text', 'hday', array(
            'label'      => 'Day:',
            'required'   => true,
            'readonly'   => true,
            'style' => 'width:40px;',
            'filters'    => array('StringTrim'),
            'decorators' => array('Errors','Label',
            'ViewHelper'),
            'validators' => array(
               array('Between', false, array('min' => 1, 'max' => 31)))
        ));
        //http://zend-framework-community.634137.n4.nabble.com/Zend-Form-Decorators-Multiple-Buttons-On-One-Line-td642790.html
        $this->addDisplayGroup(array('hyear', 'hmonth', 'hday'), 'hireDate', array( 
        'decorators' => array( 
            'FormElements', 
            array('HtmlTag', array('tag' => 'p', 'class' => 'element')), 
            ),
        )); 
        
        
        // Add the insert button
        $this->addElement('submit', 'submit', array(
            'onclick'  => 'return confirm(\'Really Delete?\')',
            'ignore'   => true,
            'label'    => 'Delete Employee',
        ));
        
        // Add the cancel button
        $this->addElement('submit', 'cancel', array(
            'ignore'   => true,
            'label'    => 'Cancel',
        ));

        // And finally add some CSRF protection
        $this->addElement('hash', 'csrf', array(
            'ignore' => true,
        ));
    }


}

