<?php
//links salaries in db to rest of application
class Application_Model_SalaryMapper
{

        //has a zend db table
        protected $_dbTable;
        /*specific to the salaries table;
        the present salary has an end date of January 1st 9999*/
        protected $_maxToDate = "9999-01-01";
     
        public function setDbTable($dbTable)
        {
            if (is_string($dbTable)) {
                $dbTable = new $dbTable();
            }
            if (!$dbTable instanceof Zend_Db_Table_Abstract) {
                throw new Exception('Invalid table data gateway provided');
            }
            $this->_dbTable = $dbTable;
            return $this;
        }
     
        public function getDbTable()
        {
            if (null === $this->_dbTable) {
                $this->setDbTable('Application_Model_DbTable_Salaries');
            }
            return $this->_dbTable;
        }    
        
        //get # of salary records, helpful for display logic
    public function getCount($employeeID)
    {
             
        $select = $this->getDbTable()->select();
        $select->from('salaries', 'count(*) as numrecords');
        $select->where("emp_no = '$employeeID'");
        $rows = $this->getDbTable()->fetchAll($select);
        return($rows[0]->numrecords);       
        
    }
    
    //get every salary record (no limit, no paging)
    //returns an array of salary records
    public function getAllSalaries($employeeID)
    {
            $where = null;
            if ($employeeID != "")
                $where = "emp_no = '$employeeID'";
            $order = "from_date DESC";
            $limit = null;
            $offset = null;
            $resultSet = $this->getDbTable()->fetchAll($where,$order,$limit,$offset);
            $entries = array();
            foreach ($resultSet as $row) {
                $entry = new Application_Model_Salary();
                $entry->setEmpNo($row->emp_no);
                $entry->setSalary($row->salary);
                $entry->setFromDt($row->from_date);
                $entry->setToDate($row->to_date);
                $entries[] = $entry;
            }
            return $entries;            
        
    }
    
    //gets latest salary for an employee
    public function getASalary($empID)
    {
            $where = "emp_no = '$empID' AND to_date = '$this->_maxToDate'";
            $result = $this->getDbTable()->fetchRow($where);

                $entry = new Application_Model_Salary();
                $entry->setEmpNo($result->emp_no);
                $entry->setSalary($result->salary);
                $entry->setFromDt($result->from_date);
                $entry->setToDate($result->to_date);

            return $entry;        
    }
    
    //creates a new salary record
    public function save(Application_Model_Salary $salary)
    {
        //basic parameters
        $empID = $salary->getEmpNo();
        $newsal = $salary->getSalary();
        $today = date("Y-m-d");
        
        //arrays for inserting/updating
        $upd_data = array(
                    'to_date' => $today
                    );
        $upd_where = array(
                    'emp_no = ?' => $empID,
                    'to_date' => $this->_maxToDate
                    );//hope AND is default! :-)
        $ins_data = array(
                    'emp_no' => $empID,
                    'salary' => $newsal,
                    'from_date' => $today,
                    'to_date' => $this->_maxToDate
                    );
        
        //is there an existing salary record?
        $existingRecords = $this->getCount($empID);
        
        if ($existingRecords > 0) //update last salary record, insert new one
            {
                    $this->getDbTable()->update($upd_data, $upd_where);
                    $this->getDbTable()->insert($ins_data);
            }
            
        else //just insert new salary record
            {
                    $this->getDbTable()->insert($ins_data);
            }
        
    }

}

